#cython: language_level=3

from ..capi.obitaxonomy cimport ecotx_t, OBIDMS_taxonomy_p

from ..dms cimport DMS

from ..object cimport OBIWrapper                          


cdef class Taxonomy(OBIWrapper) :
    cdef str  _name     # TODO keep as bytes?
    cdef DMS  _dms
    
    cdef inline OBIDMS_taxonomy_p pointer(self)

    cpdef get_taxon_by_idx(self, int idx)
    cpdef write(self, str prefix)
    cpdef int add_taxon(self, str name, str rank_name, int parent_taxid, int min_taxid=*)
 
cdef class Taxon :
    cdef ecotx_t*      _pointer
    cdef Taxonomy  _tax